/*
Odkrywanie świata Arduino, Wydanie drugie
Listing 8.2: Automatyczne blokowanie komputera w zależności od poziomu oświetlenia
https://www.exploringarduino.com/content2/ch8

Wszelkie prawa zastrzeżone 2019 Jeremy Blum ( https://www.jeremyblum.com )
Licencja MIT ( https://github.com/sciguy14/Exploring-Arduino-2nd-Edition/blob/master/LICENSE.md )
*/

//Blokowanie komputera po wyłączeniu światła

#include <Keyboard.h>

const int LIGHT     =1;    //Czujnik światła podłączony do analogowego pinu 0
const int THRESHOLD =500;  //Poziom jasności musi spaść poniżej tej wartości, aby komputer się zablokował

void setup()
{
  Keyboard.begin(); 
}

void loop()
{
  int brightness = analogRead(LIGHT);    //Odczytaj wartość zwracaną przez fotorezystor
 
  if (brightness < THRESHOLD)
  {
    Keyboard.press(KEY_LEFT_GUI);
    Keyboard.press('l');
    delay(100);
    Keyboard.releaseAll();
  }
}
